# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see https://www.gnu.org/licenses/.

- name: Install packages
  apt:
    update_cache: yes
    pkg:
      - git
      - clang-13
      - lld-13
      - gcc
      - g++
      - rsync
    state: latest
  become: yes

- name: Create Goupile user
  user:
    name: goupile
    create_home: no
    home: /nonexistent
    shell: /usr/sbin/nologin
    system: yes
  register: goupile_user
  become: yes

- name: Prepare Goupile installation directories
  file:
    path: '{{ item }}'
    state: directory
    owner: root
    group: root
    mode: '0755'
  loop:
    - '{{ goupile_root_path }}'
    - '{{ goupile_root_path }}/domains'
    - '{{ goupile_root_path }}/sync'
    - '{{ goupile_archive_path }}'
    - '{{ goupile_snapshot_path }}'
  become: yes

- name: Prepare Goupile repository directory
  file:
    path: '{{ goupile_root_path }}/repo'
    state: directory
    owner: '{{ ansible_user | default(lookup("env", "USER"), True) }}'
    recurse: yes
  become: yes

- name: Fetch Goupile repository
  git:
    repo: '{{ goupile_repo }}'
    version: '{{ goupile_commit }}'
    dest: '{{ goupile_root_path }}/repo'
    force: yes
  become: no

- name: Install sync scripts
  template:
    src: '{{ item }}.j2'
    dest: '{{ goupile_root_path }}/sync/{{ item }}'
    mode: '0755'
  loop:
    - sync.py
    - update.sh
  become: yes

- name: Update configuration files
  template:
    src: '{{ item.src }}'
    dest: '{{ item.dest }}'
    owner: root
    group: root
    mode: '{{ item.mode }}'
  loop:
    - src: sync.ini.j2
      dest: '{{ goupile_root_path }}/sync/sync.ini'
      mode: '0600'
    - src: goupile@.service.j2
      dest: /etc/systemd/system/goupile@.service
      mode: '0644'
  register: upload_config
  become: yes

- name: Reload systemd units
  systemd:
    daemon_reload: yes
  when: upload_config.changed
  become: yes

- name: Set up Goupile update
  cron:
    name: goupile_update
    hour: '{{ goupile_update_hour }}'
    minute: 0
    state: '{{ "present" if goupile_update_auto else "absent" }}'
    job: '{{ goupile_root_path }}/sync/update.sh && {{ goupile_root_path }}/sync/sync.py'
  become: yes

- name: Update and install Goupile
  command: '{{ goupile_root_path }}/sync/update.sh'
  register: build_goupile
  changed_when: 'build_goupile.stderr_lines[-1] != "Nothing to do!" and build_goupile.stderr_lines[-2] != "Nothing to do!"'
  become: yes

- name: Sync Goupile services
  command: '{{ goupile_root_path }}/sync/sync.py'
  register: sync
  changed_when: 'sync.stderr_lines[-1] != ">>> Nothing has changed" and sync.stderr_lines[-2] != ">>> Nothing has changed"'
  become: yes
